/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "gpio.h"
#include "TEA5767Radio.h"
#include "LCD_2x16.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
LCD_HandleTypeDef lcd;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */
float freq = 105.3, freq1=105.3;


/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */
void setFreq() {
	
	if (freq > 108.0) freq = 88.0;	
	if (freq < 88.0) freq = 108.0; 
	if (freq1 > 108.0) freq1 = 88.0;
	if (freq1 < 88.0)  freq1 = 108.0;	
	setFrequency(freq);
}
/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void print_fm(float frecu) {
	
/* USER CODE END 0 */
 int line = 1, position = 2;
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_FLOAT(&lcd,frecu);
 HAL_GPIO_WritePin(GPIOC, GPIO_PIN_13, GPIO_PIN_SET);
 HAL_Delay(10);		
}
/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  short int state0 =1, state1=1;
  int line = 0, position = 0;
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */
  /* USER CODE END 2 */
  /* lcd configuration */
	
  lcd.RS.Port = GPIOC;      
  lcd.RS.Pin = GPIO_PIN_14;
  
  lcd.EN.Port = GPIOC;
  lcd.EN.Pin = GPIO_PIN_15;
  
  lcd.DB4.Port = GPIOA;
  lcd.DB4.Pin = GPIO_PIN_4;
  
  lcd.DB5.Port = GPIOA;
  lcd.DB5.Pin = GPIO_PIN_5;
  
  lcd.DB6.Port = GPIOA;
  lcd.DB6.Pin = GPIO_PIN_6;
  
  lcd.DB7.Port = GPIOA;
  lcd.DB7.Pin = GPIO_PIN_7;
	
	HAL_Delay(100);
  LCD_sendCmd(&lcd, 0x33); // Initialize controller
  LCD_sendCmd(&lcd, 0x32); // Set 4-bit mode
  LCD_sendCmd(&lcd, 0x28); // 4 bit, 2 line, 5x7
  LCD_sendCmd(&lcd, 0x06); // Cursor direction -> right
  LCD_sendCmd(&lcd, 0x0C); // Display on, cursor off
  LCD_sendCmd(&lcd, 0x01); // Clear display
  HAL_Delay(100);
	
  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
 line = 0, position = 2;
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_TEXT(&lcd,"RADIO_FM");
 line = 1, position = 8;
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_TEXT(&lcd,"MHz");
 print_fm(freq1);
 setFreq();

  while (1)
  {
    /* USER CODE END WHILE */
	
		
	 HAL_GPIO_WritePin(GPIOC, GPIO_PIN_13, GPIO_PIN_RESET);
	 
	 if (freq1 > 108.0) freq1 = 88.0;
	 if (freq1 < 88.0)  freq1 = 108.0;		
   if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==GPIO_PIN_RESET) {  
	 HAL_Delay(5); 
	 if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==GPIO_PIN_RESET) state0=0; 	
   }
   if( HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==GPIO_PIN_SET && state0==0) freq1+=0.1, freq+=0.1, print_fm(freq1), setFreq(), state0=1;	 	   
		
    /* USER CODE BEGIN 3 */
	 if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_1)==GPIO_PIN_RESET) {  
	 HAL_Delay(5); 
	 if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_1)==GPIO_PIN_RESET) state1=0; 	
   }
   if( HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_1)==GPIO_PIN_SET && state1==0) freq1-=0.1, freq-=0.1, print_fm(freq1), setFreq(), state1=1;
	 
	     
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
